# 零、前言

本书旨在为您提供实用的机器学习动手入门，其目的是使任何人都可以在该领域开始工作。 我们将主要关注深度学习方法以及如何将其用于解决重要的计算机视觉问题，但是此处获得的知识可以转移到许多不同的领域。 在此过程中，读者还将掌握如何使用流行的深度学习库 TensorFlow。

# 这本书是给谁的

任何对实用的机器学习指南（特别是深度学习和计算机视觉）感兴趣的人都将从阅读本书中受益。 此外，以下人员也将受益：

*   机器学习工程师
*   数据科学家
*   对学习深度学习和计算机视觉领域感兴趣的开发人员
*   学习机器学习的学生

# 本书涵盖的内容

第 1 章，“Tensorflow 的设置和简介”，涵盖了 TensorFlow 的设置和安装，以及编写用于机器学习的简单 Tensorflow 模型。

第 2 章，“深度学习和卷积神经网络”向您介绍了机器学习，人工智能以及人工神经网络以及如何对其进行训练。 它还涵盖了 CNN 以及如何使用 TensorFlow 训练自己的 CNN。

第 3 章，“Tensorflow 中的图像分类”，讨论了如何构建 CNN 模型以及如何训练它们以对 CIFAR10 数据集进行分类。 它还探讨了通过谈论初始化和正则化的不同方法来帮助提高我们训练后的模型的质量的方法。

第 4 章，“对象检测和分割”教授对象定位，检测和分割的基础知识以及与这些主题相关的最著名的算法。

第 5 章，“VGG，接收模块，残差和 MobileNets”向您介绍了不同的卷积神经网络设计，例如 VGGNet，GoggLeNet 和 MobileNet。

第 6 章，“自编码器，变分自编码器和生成对抗网络”，向您介绍生成模型，生成对抗网络和不同类型的编码器。

第 7 章，“迁移学习”，涵盖了迁移学习的用法并在我们自己的任务中实现。

第 8 章，“机器学习最佳实践和故障排除”，向我们介绍了如何准备并将数据集拆分为子集并执行有意义的测试。 本章还讨论了过拟合和过拟合以及解决这些问题的最佳实践。

第 9 章，“大规模训练”，教您如何在多个 GPU 和机器上训练 TensorFlow 模型。 它还涵盖了存储数据并将其输入模型的最佳实践。

# 充分利用这本书

为了充分利用本书，读者应该对 Python 编程语言以及如何安装一些必需的软件包有所了解。 本书将以简单的语言介绍所有其他内容。 安装说明将在本书和存储库中给出。

# 使用约定

本书中使用了许多文本约定。

`CodeInText`：指示文本，数据库表名称，文件夹名称，文件名，文件扩展名，路径名，虚拟 URL，用户输入和 Twitter 句柄中的代码字。 这是一个示例：“将下载的`WebStorm-10*.dmg`磁盘映像文件安装为系统中的另一个磁盘。”

代码块设置如下：

```py
import tensorflow as tf 
# XOR dataset 
XOR_X = [[0, 0], [0, 1], [1, 0], [1, 1]] 
XOR_Y = [[0], [1], [1], [0]] 

```

当我们希望引起您对代码块特定部分的注意时，相关的行或项目以粗体显示：

```py
import tensorflow as tf 
# XOR dataset 
XOR_X = [[0, 0], [0, 1], [1, 0], [1, 1]] 
XOR_Y = [[0], [1], [1], [0]] 

```

任何命令行输入或输出的编写方式如下：

```py
$ pip install numpy
$ pip install scipy
```

**粗体**：表示新术语，重要单词或您在屏幕上看到的单词。 例如，菜单或对话框中的单词会出现在这样的文本中。 这是一个示例：“从管理面板中选择系统信息。”

警告或重要提示如下所示。

提示和技巧如下所示。