# 十、参考文献

# 第 1 章

在这里，我们将学习如何安装以及 Tensorflow 的基础知识，作为我们的参考：

*   <https://www.tensorflow.org/tutorials/>
*   <https://www.tensorflow.org/install/>

# 第 2 章

本章将探讨机器学习和神经网络的原理，重点是卷积神经网络和计算机视觉。 本章的参考是：

*   <https://en.wikipedia.org/wiki/Artificial_neural_network>
*   <https://en.wikipedia.org/wiki/Timeline_of_machine_learning>
*   <http://ais.informatik.uni-freiburg.de/teaching/ss11/ki/slides/ai12_acting_under_uncertainty_handout_4up.pdf>
*   <http://yann.lecun.com/exdb/publis/pdf/lecun-98.pdf>
*   <https://www.facebook.com/yann.lecun/posts/10152820758292143>
*   <https://towardsdatascience.com/types-of-convolutions-in-deep-learning-717013397f4d>
*   <http://cs231n.stanford.edu/>
*   <http://cs224d.stanford.edu/>

# 第 3 章

本章将介绍使用深度学习进行的图像分类，以及为什么 CNN 会干扰我们现在进行计算机视觉的方式。 本章的参考是：

*   [Learning Multiple Layers of Features from Tiny Images](https://www.cs.toronto.edu/~kriz/learning-features-2009-TR.pdf), Alex Krizhevsky, 2009
*   可以在这里找到关于图像表示技术的出色回顾：*Computer Vision: Algorithms and Applications*, Richard Szeliski, 2010
*   <http://www.vision.caltech.edu/Image_Datasets/Caltech101/>
*   Griffin, Gregory and Holub, Alex and Perona, Pietro (2007) Caltech–256 *Object Category Dataset*
*   Everingham, M., Van Gool, L., Williams, C. K. I., Winn, J. and Zisserman, *A International Journal of Computer Vision*, 88(2), 303-338, 2010
*   *ImageNet Large Scale Visual Recognition Challenge*, IJCV, 2015
*   <https://wordnet.princeton.edu/>
*   *What Does Classifying More Than 10,000 Image Categories Tell Us?* Jia Deng, Alexander C. Berg, Kai Li, and Li Fei-Fei
*   [Olga Russakovsky, Jia Deng et al. (2015) *ImageNet Large Scale Visual Recognition Challenge*](https://arxiv.org/pdf/1409.0575.pdf)
*   Alex Krizhevsky, Ilya Sutskever and Geoffrey Hinton, *ImageNet Classification with Deep Convolutional Neural Networks*, 2012
*   <https://arxiv.org/pdf/1311.2901.pdf>
*   *Going deeper with convolutions* by Christian Szegedy Google Inc. et al
*   *Deep Residual Learning for Image Recognition*, Kaiming He et al.
*   <https://arxiv.org/pdf/1709.01507.pdf>
*   [批量规范化写得很好的文章，很容易理解，并且更详细地解释了该概念](https://arxiv.org/pdf/1502.03167.pdf)

# 第 4 章

在本章中，我们将学习对象检测和分割。 本章的参考是：

*   [*Rich feature hierarchies for accurate object detection and semantic segmentation*](https://arxiv.org/pdf/1311.2524.pdf)
*   [*Fast RCNN*](https://arxiv.org/pdf/1504.08083.pdf)
*   [*Faster RCNN Towards Real-Time Object Detection with Region Proposals*](https://arxiv.org/pdf/1506.01497.pdf)
*   <https://www.youtube.com/watch?v=v5bFVbQvFRk>
*   [*You Only Look Once: Unified, Real-Time Object Detection*](https://arxiv.org/pdf/1506.02640.pdf)
*   [Andrew Ng 的深度学习课程](https://coursera.org/specializations/deep-learning)
*   [*Fully Convolutional Neural Network for Semantic Segmentation*](https://people.eecs.berkeley.edu/~jonlong/long_shelhamer_fcn.pdf)
*   [Semantic Image Segmentation with Deep Convolutional Nets, Atrous Convolution, and Fully Connected CRFs](https://arxiv.org/pdf/1606.00915.pdf)

# 第 5 章

在本章中，我们将学习一些常见的 CNN 架构（即 VGG，ResNet，GoogleNet）。 本章的参考是：

*   [*Very Deep Convolutional Networks for Large-Scale Image Recognition*](https://arxiv.org/abs/1409.1556), Simonyan, K. and Zisserman, A., 2014, arXiv preprint arXiv:1409.1556
*   [*Going Deeper With Convolutions](https://arxiv.org/abs/1409.4842)
*   *Deep Residual Learning for Image Recognition*, Kaiming He, Xiangyu Zhang, Shaoqing Ren, Jian Sun, Microsoft Research
*   [*Mobilenets: Efficient Convolutional Neural Networks for Mobile Vision Applications*](https://arxiv.org/abs/1704.04861)
*   [MobileNets V2](https://arxiv.org/pdf/1801.04381.pdf)

# 第 7 章

本章将讨论迁移学习以及我们如何利用他人的模型训练来帮助我们训练自己的网络。 本章的参考是：

*   <https://www.cse.ust.hk/~qyang/Docs/2009/tkde_transfer_learning.pdf>
*   <ftp://ftp.cs.wisc.edu/machine-learning/shavlik-group/torrey.handbook09.pdf>
*   [*CNN Features off-the-shelf: an Astounding Baseline for Recognition*](https://arxiv.org/pdf/1403.6382.pdf)
*   [*DeCAF: A Deep Convolutional Activation Feature for Generic Visual Recognition*](https://arxiv.org/pdf/1310.1531.pdf)

# 第 9 章

在本书的最后一章中，我们将学习如何利用云中的并行计算机集群来加速模型训练。 本章的参考是：

*   <https://www.oreilly.com/ideas/distributed-tensorflow>
*   <https://research.fb.com/wp-content/uploads/2017/06/imagenet1kin1h5.pdf>
*   <https://learningtensorflow.com/lesson11/>
*   <https://www.tensorflow.org/deploy/distributed>
*   <https://www.tensorflow.org/programmers_guide/low_level_intro>
*   <https://github.com/tmulc18/Distributed-TensorFlow-Guide>
*   <https://clusterone.com/blog/2017/09/13/distributed-tensorflow-clusterone/>
*   <https://www.youtube.com/watch?v=-h0cWBiQ8s8&>
*   <https://www.youtube.com/watch?v=uIcqeP7MFH0>
*   <https://www.youtube.com/watch?v=bRMGoPqsn20>
*   <https://www.youtube.com/watch?v=1cHx1baKqq0>